commit 128b7a304cc4c694bc5e3c55ae525f8b91a860aa
Author: freddy77 <freddy77>
Date:   Thu Dec 17 21:08:59 2009 +0000

    Automatic odbc version selection

diff --git a/ChangeLog b/ChangeLog
index 6aaa23f..395816e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Dec 17 22:08:50 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: Automatic odbc version selection
+
 Thu Dec 17 11:33:39 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/odbc.c:
 	- Fix statistics functions for Sybase
@@ -2010,4 +2013,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2912 2009/12/17 10:33:59 freddy77 Exp $
+$Id: ChangeLog,v 1.2913 2009/12/17 21:08:59 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 3f17c30..c2387f3 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,10 +60,10 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.521 2009/12/17 10:33:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.522 2009/12/17 21:08:59 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
-static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
+static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
 static SQLRETURN _SQLAllocStmt(SQLHDBC hdbc, SQLHSTMT FAR * phstmt);
 static SQLRETURN _SQLAllocDesc(SQLHDBC hdbc, SQLHDESC FAR * phdesc);
 static SQLRETURN _SQLFreeConnect(SQLHDBC hdbc);
@@ -1320,7 +1320,7 @@ SQLAllocHandle(SQLSMALLINT HandleType, SQLHANDLE InputHandle, SQLHANDLE * Output
 		return _SQLAllocConnect(InputHandle, OutputHandle);
 		break;
 	case SQL_HANDLE_ENV:
-		return _SQLAllocEnv(OutputHandle);
+		return _SQLAllocEnv(OutputHandle, SQL_OV_ODBC3);
 		break;
 	case SQL_HANDLE_DESC:
 		return _SQLAllocDesc(InputHandle, OutputHandle);
@@ -1392,20 +1392,20 @@ SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc)
 }
 
 static SQLRETURN
-_SQLAllocEnv(SQLHENV FAR * phenv)
+_SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version)
 {
 	TDS_ENV *env;
 	TDSCONTEXT *ctx;
 
-	tdsdump_log(TDS_DBG_FUNC, "_SQLAllocEnv(%p)\n", 
-			phenv);
+	tdsdump_log(TDS_DBG_FUNC, "_SQLAllocEnv(%p, %d)\n",
+			phenv, (int) odbc_version);
 
 	env = (TDS_ENV *) calloc(1, sizeof(TDS_ENV));
 	if (!env)
 		return SQL_ERROR;
 
 	env->htype = SQL_HANDLE_ENV;
-	env->attr.odbc_version = SQL_OV_ODBC2;
+	env->attr.odbc_version = odbc_version;
 	/* TODO use it */
 	env->attr.output_nts = SQL_TRUE;
 
@@ -1432,7 +1432,7 @@ SQLAllocEnv(SQLHENV FAR * phenv)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLAllocEnv(%p)\n", phenv);
 
-	return _SQLAllocEnv(phenv);
+	return _SQLAllocEnv(phenv, SQL_OV_ODBC2);
 }
 
 static SQLRETURN

